# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
image: node:latest
variables:
  GIT_SUBMODULE_STRATEGY: recursive
  a11y_urls: https://memhamwan.gitlab.io
stages:
- build
- test
- deploy
- accessibility
build:
  stage: build
  script:
  - CI=true
  - npm install
  - npm run build
  artifacts:
    paths:
    - public
  cache:
    key: "${CI_COMMIT_REF_SLUG}"
    paths:
    - node_modules/
test:
  stage: build
  script:
  - npm install
  - npm test
  cache:
    key: "${CI_COMMIT_REF_SLUG}"
    paths:
    - node_modules/
type-check:
  stage: build
  script:
  - npm install
  - npm run type-check
  cache:
    key: "${CI_COMMIT_REF_SLUG}"
    paths:
    - node_modules/
lint:
  stage: build
  script:
  - npm install
  - npm run lint
  cache:
    key: "${CI_COMMIT_REF_SLUG}"
    paths:
    - node_modules/
pages:
  image: alpine:latest
  stage: deploy
  script:
  - echo "GitLab Pages magic happens here"
  dependencies:
  - build
  artifacts:
    paths:
    - public
  rules:
  - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
  environment:
    name: production
include:
- template: Security/Dependency-Scanning.gitlab-ci.yml
- template: Security/License-Scanning.gitlab-ci.yml
- template: Code-Quality.gitlab-ci.yml
- template: Verify/Accessibility.gitlab-ci.yml
- template: Security/Secret-Detection.gitlab-ci.yml